;{ ----- File description Header : Testprogram for the WinFX-Library -----

;======================================================================================================================
;
; Main-Project Name .:  WinFX - Library
; Project Mainfile ..:  Y:\EDV\Programmierung\PureBasic\Projekte\Library - WinFX\WinFX-Library.pbp
; Files in Project ..:  1/1/0/0/0/0/0/0/0 - (pb/pbi/userlibs/dll/images/sound/ini/data/database)
; Proj. Description .:  Library wich supplies Functions, to add additional Effects to "standard" PB-Windows
;
; This Files Name....:  WinFX-Demo.pb
; File location .....:  Y:\EDV\Programmierung\PureBasic\Projekte\Library - WinFX\
; Made public .......:  yes
; Published URL .....:  http://www.bmi-online.de/public/PB-Sources/WinFX_Demo.pb
;
; Description .......:  This file contains some testcode, to test the WinFX-Library (1/1)
;
; Includes ..........: 1
; Included Files ....: Lib_WinFX.pbi
;
; PB-Version .............:  PB 4.51  ->  x86 - tested   |   x64 - not yet tested, should work
; supported Funktionality :  x86            - yes
;                            x64            - not tested, should work
;                            EnableExplicit - yes
;                            Threadsave     - not tested, should work
;                            Unicode        - not tested, should work
;                          
; Supported Platform .....:  Windows (should work on all Windows-Versions from Win2000 to Win7)
; uses OS-API-calls ......:  No, but included Lib does.
; Tested on Systems ......:  WinXP-32Bit
;
; Copyrights .............:  Sansetsu Deutschland GmbH
; Primarily Author(s) ....:  Albert Cremers (Luke)
; Licensed as OpenSource .:  yes
; Creation Date ..........:  03.10.2010
; Version ................:  1.1.0.2
; Last Update ............:  06.10.2010
; Modification(s) by .....:  corrected some spelling mistakes (more to be done)   ;)
;                            Added support for the new Skinning-Color Option in WinFX_Transparency()
; Date, last Modification :  
; Descr. of Modifications :  
; Remarks ................:  
;}=====================================================================================================================

EnableExplicit

;{ ----- Includes
XIncludeFile "..\includes\Lib_WinFX.pbi"			; File available at: http://www.bmi-online.de/public/PB-Sources/includes/Lib_WinFX.pbi
;}
;{ ----- Enumerations
Enumeration	;{ Windows
	#Win_Main
	#Win_FX
EndEnumeration ;}
Enumeration	;{ Gadgets
	; Gadgets fr Main-Window
	#GadChB_Transparency
	#GadTrB_Transparency
	#GadTex_TransparencyValue
	#GadChB_Skinning
	#GadChB_HideFromTaskbar
	#GadChB_ClickThrough
	#GadBtn_TurnOffLayer
	#GadLiI_WinMainEvents
	#GadLiI_WinFXEvents
	#GadWeb_ClickThroughTest
	; Gadgets for WinFX-Window
	#GadImg_BackGround
	#GadStr_Info1
	#GadStr_Info2
	#GadStr_Info3
	#GadStr_Info4
	#GadStr_Info5
	#GadStr_Info6
	#GadStr_Info7
	#GadStr_Info8
	#GadStr_Info9
	#GadStr_Info10
	#GadStr_Info11
	#GadStr_Info12
	#GadStr_Info13
	#GadStr_State1
	#GadStr_State2
	#GadStr_State3

EndEnumeration	;}
;} End of Enumerations
;{ ----- Declarations
#WinBGColor = $ffaaaa
Define	Event, Gadget
Define	StatusChanged
;}
;{ ----- Procedures
Procedure	OpenMainWindow(WinNr)		; Open the Main-Window and add some Gadget
	Protected	ProcReturnValue = #False
	Protected	WinWidth		= 850
	Protected	WinHeight	= 540
	Protected	WinXPos		= (DesktopWidth(0) - WinWidth) / 2 - 120
	Protected	WinYPos		= (DesktopHeight(0) - WinHeight) / 2 - 40
	If OpenWindow(WinNr, WinXPos, WinYPos, WinWidth, WinHeight, "Main-Window  |  WinFX Test-Program", #PB_Window_SystemMenu)
		CheckBoxGadget(#GadChB_Transparency		,  10,   5, 115, 24,"Transparency effect")
		TrackBarGadget(#GadTrB_Transparency		, 129,   5, 300, 24, 0, 100)
		TextGadget(#GadTex_TransparencyValue	, 440,   5,  50, 24, "", #PB_Text_Center)
		CheckBoxGadget(#GadChB_Skinning			,  10,  35, 115, 24,"Window skinning")
		CheckBoxGadget(#GadChB_HideFromTaskbar	,  10,  65, 115, 24,"Hide from TaskBar")
		CheckBoxGadget(#GadChB_ClickThrough		,  10,  95, 115, 24,"Click-Through Mode")
		ButtonGadget(#GadBtn_TurnOffLayer		,  10, 127, 115, 24,"Turn off 'layered' Mode")
		ListIconGadget(#GadLiI_WinMainEvents	,  10, 160, 115, (WinHeight - 170)/2, "Events: Main", 94)
		ListIconGadget(#GadLiI_WinFXEvents		,  10, 165 + GadgetHeight(#GadLiI_WinMainEvents), 115, WinHeight - 170 - GadgetHeight(#GadLiI_WinMainEvents), "Events: WinFX", 94)
		WebGadget(#GadWeb_ClickThroughTest		, 130,  35, WinWidth - 135, WinHeight - 40,"http://www.purebasic.fr/german/search.php?search_id=active_topics")
		SetGadgetState(#GadTrB_Transparency, 30)
		DisableGadget(#GadTrB_Transparency, #True)
		ProcReturnValue = #True
	EndIf
	ProcedureReturn ProcReturnValue
EndProcedure
Procedure	OpenFXWindow(WinNr)		; Open the WinFX-Window. Ths Window will be affected by the WinFX-effects
	Protected	ProcReturnValue = #False
	Protected	Counter
	Protected	TextColor2	= $664444
	Protected	GadgetColor	= $ff9999
	Protected	GadgetYPos	= 20
; 	Protected	WinColor		= $ffaaaa
	Protected	WinWidth		= 850
	Protected	WinHeight	= 540
	Protected	WinXPos		= (DesktopWidth(0) - WinWidth) / 2 + 120
	Protected	WinYPos		= (DesktopHeight(0) - WinHeight) / 2 + 40
	If OpenWindow(WinNr, WinXPos, WinYPos, WinWidth, WinHeight, "WinFX-Window  |  This window will be effected by WinFX", #PB_Window_SystemMenu)
		
		; Creating Image and Gadget for Background
		If CreateImage(0, WinWidth, WinHeight+10)
			If StartDrawing(ImageOutput(0))
				Box(0,0, WinWidth, WinHeight+10, #WinBGColor)
				StopDrawing()
			EndIf
			ImageGadget(#GadImg_BackGround, 0, 0, WinWidth, WinHeight+10, ImageID(0))
			DisableGadget(#GadImg_BackGround, #True)
		EndIf
		
		StringGadget(#GadStr_Info1 , 20,  GadgetYPos, WinWidth-40, 40, "This Window will be affected by the WinFX-Functions.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 50
		StringGadget(#GadStr_Info2 , 20,  GadgetYPos, WinWidth-40, 22, "Use the Buttons in the window beneath left, to change the WinFX-Effects for this window.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 35
		StringGadget(#GadStr_Info3 , 20,  GadgetYPos, WinWidth-40, 22, "'Transparency effect' will turn on/off the windows-transparency (change the level with the slider).", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 35
		StringGadget(#GadStr_Info4 , 20,  GadgetYPos, WinWidth-40, 22, "'Hide from TaskBar' will change the Window into a ToolWindow to hide it from the Taskbar.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 23
		StringGadget(#GadStr_Info5 , 20,  GadgetYPos, WinWidth-40, 22, "     Note: This causes a slightly change in design an functionality.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 35
		StringGadget(#GadStr_Info6 , 20,  GadgetYPos, WinWidth-40, 22, "'Click-Through Mode' will turn the window into a 'click-through' state.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 23
		StringGadget(#GadStr_Info7 , 20,  GadgetYPos, WinWidth-40, 22, "     In this state, all clicks and events will go directly through it to the window beneath.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 23
		StringGadget(#GadStr_Info8 , 20,  GadgetYPos, WinWidth-40, 22, "     So - referring to MouseEvents - the window just doesn't exists anymore.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 23
		StringGadget(#GadStr_Info9 , 20,  GadgetYPos, WinWidth-40, 22, "     Use the Webgadet in the window beneath to see, that even the mousepointer changes.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 23
		StringGadget(#GadStr_Info10, 20,  GadgetYPos, WinWidth-40, 25, "     (The Events-Lists on the left will show all the Events, the windows will receive.)", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 35
		StringGadget(#GadStr_Info11, 20,  GadgetYPos, WinWidth-40, 25, "'Turn off layered Mode' turns off all effects that needs a 'layered' Window.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 23
		StringGadget(#GadStr_Info12, 20,  GadgetYPos, WinWidth-40, 25, "     Note: The 'Transparency effect' and the 'click-through' effect need a 'layered' window.", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 45
		StringGadget(#GadStr_Info13, 20,  GadgetYPos, WinWidth-40, 25, "Results from:", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 35
		StringGadget(#GadStr_state1, 20,  GadgetYPos, WinWidth-40, 25, "", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 30
		StringGadget(#GadStr_State2, 20,  GadgetYPos, WinWidth-40, 25, "", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 30
		StringGadget(#GadStr_State3, 20,  GadgetYPos, WinWidth-40, 25, "", #PB_String_ReadOnly | #PB_String_BorderLess) : GadgetYPos + 30
		
		SetGadgetColor(#GadStr_Info5, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_Info7, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_Info8, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_Info9, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_Info10, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_Info12, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_State1, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_State2, #PB_Gadget_FrontColor, TextColor2)
		SetGadgetColor(#GadStr_State3, #PB_Gadget_FrontColor, TextColor2)
		
		SetGadgetColor(#GadStr_Info1, #PB_Gadget_BackColor, GadgetColor)
		SetGadgetFont(#GadStr_Info1, FontID(1))
		For Counter = #GadStr_Info2 To #GadStr_State3
			SetGadgetColor(Counter, #PB_Gadget_BackColor, #WinBGColor)
			SetGadgetFont(Counter, FontID(0))
		Next
		SetGadgetFont(#GadStr_State1, FontID(2))
		SetGadgetFont(#GadStr_State2, FontID(2))
		SetGadgetFont(#GadStr_State3, FontID(2))

		StickyWindow(#Win_FX, #True)

		ProcReturnValue = #True
	EndIf
	ProcedureReturn ProcReturnValue
EndProcedure
Procedure	UpdateStatus()
	
	; Update Slider-Value, shown in the TextGadget
	SetGadgetText(#GadTex_TransparencyValue, Str(GetGadgetState(#GadTrB_Transparency)))
	
	; Now we use the WinFX_Get...-Functions to update the info in the WinFX-Window
	
	If WinFX_GetLayerState(#Win_FX)
		SetGadgetText(#GadStr_State1, "    WinFX_GetLayerState() = #True                 >  'Transparency effect' or 'click-through' Mode is active.")
	Else
		SetGadgetText(#GadStr_State1, "    WinFX_GetLayerState() = #False               >  No effect that needs a 'layered' Window is active.")
	EndIf	
	
	If WinFX_GetTaskBarState(#Win_FX)
		SetGadgetText(#GadStr_State2, "    WinFX_GetTaskBarState() = #True            >  Window is hidden from TaskBar.")
	Else
		SetGadgetText(#GadStr_State2, "    WinFX_GetTaskBarState() = #False           >  Window is NOT hidden from TaskBar.")
	EndIf	
	
	If WinFX_GetClickThroughState(#Win_FX)
		SetGadgetText(#GadStr_State3, "    WinFX_GetClickThroughState() = #True    >  Window in 'click-through' Mode. Window will pass through all events")
	Else
		SetGadgetText(#GadStr_State3, "    WinFX_GetClickThroughState() = #False   >  Window in 'normal' Mode. Window will catch events as usual.")
	EndIf	
	
EndProcedure
;} 
;{ ----- Loading Fonts
If Not LoadFont(0, "Arial", 14) Or Not LoadFont(1, "Arial", 25) Or Not LoadFont(2, "Arial Narrow", 14)
	MessageRequester("Attention!","Could not load Font !!!")
	End
EndIf
;}

ExamineDesktops()

; ===== Main =====

If OpenMainWindow(#Win_Main)
	If OpenFXWindow(#Win_FX)
		
		UpdateStatus()
		
		;{ ----- Event-Loop -----
		Repeat
			Event = WaitWindowEvent()
			
			; ----- aufgetretene Events in Eventliste des jeweiligen Fensters eintragen
			If EventWindow() = #Win_Main
				If Event <> 15 And Event <> 275
					AddGadgetItem(#GadLiI_WinMainEvents,0,Str(ElapsedMilliseconds())+", "+Str(Event))
				EndIf
			Else
				AddGadgetItem(#GadLiI_WinFXEvents,0,Str(ElapsedMilliseconds())+", "+Str(Event))
			EndIf
			
			; ----- Gadget-Events auswerten
			If Event = #PB_Event_Gadget
				StatusChanged = #True
				Select	EventGadget()
						
					Case	#GadChB_Transparency		;{ ----- CheckBox - Status of Transparency effect changed
						
						If GetGadgetState(#GadChB_Transparency) = #PB_Checkbox_Checked
							If GetGadgetState(#GadChB_Skinning) = #PB_Checkbox_Checked
								WinFX_Transparency(#Win_FX, GetGadgetState(#GadTrB_Transparency), #WinBGColor)
							Else
								WinFX_Transparency(#Win_FX, GetGadgetState(#GadTrB_Transparency), #WinFX_NoSkinning)
							EndIf
 							DisableGadget(#GadTrB_Transparency, #False)
						Else
							If GetGadgetState(#GadChB_Skinning) = #PB_Checkbox_Checked
								WinFX_Transparency(#Win_FX, 0, #WinBGColor)
							Else
								WinFX_Transparency(#Win_FX, -1)
							EndIf
 							DisableGadget(#GadTrB_Transparency, #True)
						EndIf
						;}
					Case	#GadTrB_Transparency		;{ ----- TrackBar - Value of Transparency changed
						
						If GetGadgetState(#GadChB_Skinning) = #PB_Checkbox_Checked
							WinFX_Transparency(#Win_FX, GetGadgetState(#GadTrB_Transparency), #WinBGColor)
						Else
							WinFX_Transparency(#Win_FX, GetGadgetState(#GadTrB_Transparency), #WinFX_NoSkinning)
						EndIf
						;}
					Case	#GadChB_Skinning			;{ ----- CheckBox - Color-Keying (Skinning) aktivated
						
						If GetGadgetState(#GadChB_Skinning) = #PB_Checkbox_Checked
							If GetGadgetState(#GadChB_Transparency) = #PB_Checkbox_Checked
								WinFX_Transparency(#Win_FX, GetGadgetState(#GadTrB_Transparency), #WinBGColor)
							Else
								WinFX_Transparency(#Win_FX, 0, #WinBGColor)
							EndIf
						Else
							If GetGadgetState(#GadChB_Transparency) = #PB_Checkbox_Checked
								WinFX_Transparency(#Win_FX, GetGadgetState(#GadTrB_Transparency))
							Else
								WinFX_Transparency(#Win_FX, -1)
							EndIf
						EndIf
						;}
					Case	#GadChB_HideFromTaskbar	;{ ----- Status for Hide-from-TaskBar changed
						
						If GetGadgetState(#GadChB_HideFromTaskbar) = #PB_Checkbox_Checked
							WinFX_HideFromTaskBar(#Win_FX, #True)
						Else
							WinFX_HideFromTaskBar(#Win_FX, #False)
						EndIf
						;}
					Case	#GadChB_ClickThrough		;{ ----- Status for "click-through" Mode changed
						
						If GetGadgetState(#GadChB_ClickThrough) = #PB_Checkbox_Checked
							WinFX_ClickThrough(#Win_FX, #True)
						Else
							WinFX_ClickThrough(#Win_FX, #False)
						EndIf
						;}
					Case	#GadBtn_TurnOffLayer		;{ ----- Button pressed: "Turn of Layer Mode"
						
						WinFX_TurnOffLayer(#Win_FX)
						SetGadgetState(#GadChB_ClickThrough, #PB_Checkbox_Unchecked)
						SetGadgetState(#GadChB_Transparency, #PB_Checkbox_Unchecked)
						DisableGadget(#GadTrB_Transparency, #True)
						;}
					Default
						StatusChanged = #False
				EndSelect
				If StatusChanged
					UpdateStatus()
				EndIf
			EndIf
			
		Until Event = #PB_Event_CloseWindow
		;}
		
	EndIf
EndIf
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 20
; FirstLine = 2
; Folding = BAA-
; EnableXP